#include "stdafx.h"
#include "PCIELM4_MC.h"

CStringW GetErrorString(long eError, CStringA strFunNameA, WORD wBoardNo, WORD wAxisNo)
{

    CStringW strError, strBoard, strAxis;
    CStringW strRet;
	CStringW strFuncNameW;
	wchar_t *pwFuncName;
	long lLength; 

	//Convert ASCI string to UNICODE string:
	lLength = ::MultiByteToWideChar(CP_UTF8, 0, strFunNameA, -1, NULL, 0);
	pwFuncName = strFuncNameW.GetBuffer(lLength);
	::MultiByteToWideChar(CP_UTF8, 0, strFunNameA, -1, pwFuncName, lLength);
	strFuncNameW.ReleaseBuffer();

	//Add the board and axis number to the string  
	strBoard.Format(L"m_bBoardNo= %d", wBoardNo);
	strAxis.Format(L"AxisNo= %d", wAxisNo);
	strFuncNameW.Replace(L"m_bBoardNo", strBoard);
	strFuncNameW.Replace(L"AxisNo", strAxis);


	switch(eError)
	{
	case PCIELM4_SUCCESS:
		 strError.Format(L"SUCCESS");
		 break;
	case PCIELM4_ERROR: 
		 strError.Format(L"ERROR");
		 break;
	case ERR_CARD_NOT_FOUND: 
		 strError.Format(L"ERR_CARD_NOT_FOUND");
		 break;
	case ERR_INVALID_SLOT_NO: 
		 strError.Format(L"ERR_INVALID_SLOT_NO");
		 break;
	case ERR_INVALID_PARA: 
		 strError.Format(L"ERR_INVALID_PARA");
		 break;
	case ERR_INVALID_DRIVING_SPEED: 
		 strError.Format(L"ERR_INVALID_DRIVING_SPEED");
		 break;
	case ERR_INVALID_START_SPEED: 
		 strError.Format(L"ERR_INVALID_START_SPEED");
		 break;
    case ERR_INVALID_END_SPEED:
         strError.Format(L"ERR_INVALID_END_SPEED");
		 break;
	case ERR_INVALID_MPG_SPEED: 
		 strError.Format(L"ERR_INVALID_MPG_SPEED");
		 break;
	case ERR_INVALID_MOVE_DIRECTION: 
		 strError.Format(L"ERR_INVALID_MOVE_DIRECTION");
		 break;
	case ERR_AXES_NOT_MATCH: 
		 strError.Format(L"ERR_AXES_NOT_MATCH");
		 break;
	
	//=================================================
	// Group related errors:
	//=================================================
	//case ERR_GROUP_NOT_CONFIG: 
	//	 strError.Format(L"ERR_GROUP_NOT_CONFIG");
	//	 break;
	case ERR_GROUP_INVALID_DIMENSION: 
		 strError.Format(L"ERR_GROUP_INVALID_DIMENSION");
		 break;
	case ERR_INVALID_GROUP_AXES: 
		 strError.Format(L"ERR_INVALID_GROUP_AXES");
		 break;
	case ERR_GROUP_NOT_CONFIGURED: 
		 strError.Format(L"ERR_GROUP_NOT_CONFIGURED");
		 break;
	 case ERR_GROUP_OUT_OF_RANGE: 
		 strError.Format(L"ERR_GROUP_OUT_OF_RANGE");
		 break;
	case ERR_INCORRECT_GROUP_ASSIGNED: 
		 strError.Format(L"ERR_INCORRECT_GROUP_ASSIGNED");
		 break;
 	case ERR_GROUP_SAME_AXIS: 
		 strError.Format(L"ERR_GROUP_SAME_AXIS");
		 break;
 	case ERR_GROUP_RELEASE_REQUIRED: 
		 strError.Format(L"ERR_GROUP_RELEASE_REQUIRED");
		 break;
 	//case ERR_INVALID_GROUP_NO: 
	//	 strError.Format(L"ERR_INVALID_GROUP_NO");
	//	 break;
//--------


	case ERR_MOTION_NOT_FINISHED: 
		 strError.Format(L"ERR_MOTION_NOT_FINISHED");
		 break;
	case ERR_CARD_NOT_REGISTERED: 
		 strError.Format(L"ERR_CARD_NOT_REGISTERED");
		 break;
	case ERR_INVALID_AXIS: 
		 strError.Format(L"ERR_INVALID_AXIS");
		 break;
	case ERR_AXIS_ERROR: 
		 strError.Format(L"ERR_AXIS_ERROR");
		 break;
	case ERR_CMD_NO_CLOSED_LOOP_SUPPORT: 
		 strError.Format(L"ERR_CMD_NO_CLOSED_LOOP_SUPPORT");
		 break;

	case ERR_INTERPOL_NOT_CONFIGURED: 
		 strError.Format(L"ERR_INTERPOL_NOT_CONFIGURED");
		 break;
	case ERR_INVALID_HELICAL_MODE: 
		 strError.Format(L"ERR_INVALID_HELICAL_MODE");
		 break;
	case ERR_INVALID_FRNET_SPEED_SETTING: 
		 strError.Format(L"ERR_INVALID_FRNET_SPEED_SETTING");
		 break;
	case ERR_INVALID_FRNET_SA_GROUP_ADDR: 
		 strError.Format(L"ERR_INVALID_FRNET_SA_GROUP_ADDR");
		 break;
	case ERR_INVALID_FRNET_RA_GROUP_ADDR: 
		 strError.Format(L"ERR_INVALID_FRNET_RA_GROUP_ADDR");
		 break;
	case ERR_INVALID_MPG_GAIN: 
		 strError.Format(L"ERR_INVALID_MPG_GAIN");
		 break;
	case ERR_MPG_NOT_CONFIGURED: 
		 strError.Format(L"ERR_MPG_NOT_CONFIGURED");
		 break;
	case ERR_MOTION_IS_COMPLETED: 
		 strError.Format(L"ERR_MOTION_IS_COMPLETED");
		 break;


	case ERR_CMD_NOT_FOR_CONTI_INTERPOL: 
		 strError.Format(L"ERR_CMD_NOT_FOR_CONTI_INTERPOL");
		 break;
	case ERR_MODE_NOT_FOR_CONTI_INTERPOL: 
		 strError.Format(L"ERR_MODE_NOT_FOR_CONTI_INTERPOL");
		 break;	
	case ERR_DPRAM_RTC_BLOCKS_AVAILABLE: 
		 strError.Format(L"ERR_DPRAM_RTC_BLOCKS_AVAILABLE");
		 break;
	case ERR_DPRAM_RTC_BUFFER_FULL: 
		 strError.Format(L"ERR_DPRAM_RTC_BUFFER_FULL");
		 break;
	case EMG_ACVTIVATED: 
		 strError.Format(L"EMG_ACVTIVATED");
		 break;


	case ERR_CONFLICT_CONTI_INTERP_CONFIG: 
		 strError.Format(L"ERR_CONFLICT_CONTI_INTERP_CONFIG");
		 break;
	case ERR_CONTI_INTERP_INVALID_CONFIG: 
		 strError.Format(L"ERR_CONTI_INTERP_INVALID_CONFIG");
		 break;
	case ERR_CONTI_INTERP_INTERRUPTED: 
		 strError.Format(L"ERR_CONTI_INTERP_INTERRUPTED");
		 break;
	case ERR_CONTI_INTERP_INVALID_START: 
		 strError.Format(L"ERR_CONTI_INTERP_INVALID_START");
		 break;
	case ERR_CONTI_INTERP_FIFO_EMPTY: 
		 strError.Format(L"ERR_CONTI_INTERP_FIFO_EMPTY");
		 break;
	case ERR_NOT_IN_CONTI_INTERP_MODE: 
		 strError.Format(L"ERR_NOT_IN_CONTI_INTERP_MODE");
		 break;
	case ERR_CONTI_INTERP_START: 
		 strError.Format(L"ERR_CONTI_INTERP_START");
		 break;
	case ERR_INVALID_RING_COUNTER: 
		 strError.Format(L"ERR_INVALID_RING_COUNTER");
		 break;
	case ERR_ISR_IS_USED_FOR_CMP_TRIG: 
		 strError.Format(L"ERR_ISR_IS_USED_FOR_CMP_TRIG");
		 break;


	case ERR_RTC_WAIT_ABORTED: 
		 strError.Format(L"ERR_RTC_WAIT_ABORTED");
		 break;
	case ERR_RTC_TIMEOUT: 
		 strError.Format(L"ERR_RTC_TIMEOUT");
		 break;
	case ERR_DSP_RESET: 
		 strError.Format(L"ERR_DSP_RESET");
		 break;
    case ERR_DDA_IS_BUSY:
         strError.Format(L"ERR_DDA_IS_BUSY");
		 break;
//	case INFO_SET_DDA_NOT_REQUIRED: 
//		 strError.Format(L"INFO_SET_DDA_NOT_REQUIRED");
		 break;
    case ERR_EXCEED_MAX_POSTION:
		 strError.Format(L"ERR_EXCEED_MAX_POSTION");
		 break;
    case ERR_NOT_SUPPORTED_BY_VRING_MODE:
		 strError.Format(L"ERR_NOT_SUPPORTED_BY_VRING_MODE");
		 break;

    case ERR_DLL_DO_NOT_SUPPORT_MULTI_APP:
		 strError.Format(L"ERR_DLL_DO_NOT_SUPPORT_MULTI_APP");
		 break;

    case ERR_DRIVER_NOT_OPEN:
		 strError.Format(L"ERR_DRIVER_NOT_OPEN");
		 break;

	case ERR_NO_BOARD:
		 strError.Format(L"ERR_NO_BOARD");
		 break;

     case ERR_API_NOT_SUPPORTED:
		 strError.Format(L"ERR_API_NOT_SUPPORTED");
		 break;


	//================================================
	// -- DSP error read from the Read/Write flag of DPRAM BLOCK
	//================================================

	case ERR_DSP_SYSTEM_ERROR: 
		 strError.Format(L"ERR_DSP_SYSTEM_ERROR");
		 break;
	case ERR_DSP_NOT_IMPLEMENT: 
		 strError.Format(L"ERR_DSP_NOT_IMPLEMENT");
		 break;

    //-1000:
	case ERR_DSP_MOTIONPATH_FULL: 
		 strError.Format(L"ERR_DSP_MOTIONPATH_FULL");
		 break;
	case ERR_DSP_REMAIN_STILL: 
		 strError.Format(L"ERR_DSP_REMAIN_STILL");
		 break;
	case ERR_DSP_DIMENSION_OUT_RANGE: 
		 strError.Format(L"ERR_DSP_DIMENSION_OUT_RANGE");
		 break;
	case ERR_DSP_SPEED_VALUE: 
		 strError.Format(L"ERR_DSP_SPEED_VALUE");
		 break;	
	case ERR_DSP_SMALLSHAPE_ERROR: 
		 strError.Format(L"ERR_DSP_SMALLSHAPE_ERROR");
		 break;	
	case ERR_DSP_SAWSHAPE_ERROR: 
		 strError.Format(L"ERR_DSP_SAWSHAPE_ERROR");
		 break;	
	case ERR_DSP_AXIS_INUSE: 
		 strError.Format(L"ERR_DSP_AXIS_INUSE");
		 break;	
	case ERR_DSP_NORMALVECTOR: 
		 strError.Format(L"ERR_DSP_NORMALVECTOR");
		 break;
	case ERR_DSP_CIRCLE_RADIUS: 
		 strError.Format(L"ERR_DSP_CIRCLE_RADIUS");
		 break;
    case ERR_DSP_MECH_PARA_VALUE:
         strError.Format(L"ERR_DSP_MECH_PARA_VALUE");
		 break;



    //-1100:
    case ERR_DSP_MOTIONPATH_ALREADY_FREE: 
		 strError.Format(L"ERR_DSP_MOTIONPATH_ALREADY_FREE");
		 break;
	case ERR_DSP_EXCEED_SPEED_LIMIT: 
		 strError.Format(L"ERR_DSP_EXCEED_SPEED_LIMIT");
		 break;
    case ERR_DSP_EXCEED_VRING_LIMIT:
		 strError.Format(L"ERR_DSP_EXCEED_VRING_LIMIT");
		 break;
    case ERR_DSP_EXCEED_MAX_POSTION:
         strError.Format(L"ERR_DSP_EXCEED_MAX_POSTION");
		 break;


     //-2000:
	case ERR_DSP_NO_COMMAND: 
		 strError.Format(L"ERR_DSP_NO_COMMAND");
		 break;
	case ERR_DSP_CRC_ERROR: 
		 strError.Format(L"ERR_DSP_CRC_ERROR");
		 break;
	case ERR_DSP_UNKNOWN_COMMAND: 
		 strError.Format(L"ERR_DSP_UNKNOWN_COMMAND");
		 break;
	case ERR_DSP_MULTIBLOCK_CMD: 
		 strError.Format(L"ERR_DSP_MULTIBLOCK_CMD");
		 break;
	case ERR_DSP_ACC_TYPE: 
		 strError.Format(L"ERR_DSP_ACC_TYPE");
		 break;
	case ERR_DSP_DEC_TYPE: 
		 strError.Format(L"ERR_DSP_DEC_TYPE");
		 break;
	case ERR_DSP_CMD_NOT_ALLOWED: 
		 strError.Format(L"ERR_DSP_CMD_NOT_ALLOWED");
		 break;

	case ERR_DSP_INHIBIT_BY_EMG: 
		 strError.Format(L"ERR_DSP_INHIBIT_BY_EMG");
		 break;
 	case ERR_DSP_INHIBIT_BY_MPG_EMG: 
		 strError.Format(L"ERR_DSP_INHIBIT_BY_MPG_EMG");
		 break;
  	case ERR_DSP_INHIBIT_BY_PEL: 
		 strError.Format(L"ERR_DSP_INHIBIT_BY_PEL");
		 break;
  	case ERR_DSP_INHIBIT_BY_MEL: 
		 strError.Format(L"ERR_DSP_INHIBIT_BY_MEL");
		 break;
   	case ERR_DSP_INHIBIT_BY_ALM: 
		 strError.Format(L"ERR_DSP_INHIBIT_BY_ALM");
		 break;
    case ERR_DSP_INHIBIT_BY_RDY: 
		 strError.Format(L"ERR_DSP_INHIBIT_BY_RDY");
		 break;



     //-2100:
    case ERR_DSP_GROUP_OUT_RANGE: 
		 strError.Format(L"ERR_DSP_GROUP_OUT_RANGE");
		 break;
    case ERR_DSP_GROUP_ALREADY_FREE: 
		 strError.Format(L"ERR_DSP_GROUP_ALREADY_FREE");
		 break;
    case ERR_DSP_GROUP_ASSIGNED: 
		 strError.Format(L"ERR_DSP_GROUP_ASSIGNED");
		 break;
    case ERR_DSP_GROUP_INUSE: 
		 strError.Format(L"ERR_DSP_GROUP_INUSE");
		 break;
    case ERR_DSP_GROUP_NOT_INUSE: 
		 strError.Format(L"ERR_DSP_GROUP_NOT_INUSE");
		 break;
    case ERR_DSP_AXIS_ASSIGNED: 
		 strError.Format(L"ERR_DSP_AXIS_ASSIGNED");
		 break;

    //-2200:
    case ERR_DSP_CONTROL_MODE: 
		 strError.Format(L"ERR_DSP_CONTROL_MODE");
		 break;
    
    //-2300:
    case ERR_DSP_BUFFER_FULL: 
		 strError.Format(L"ERR_DSP_BUFFER_FULL");
		 break;
    case ERR_DSP_BUFFER_INFO: 
		 strError.Format(L"ERR_DSP_BUFFER_INFO");
		 break;
    case ERR_DSP_BUFFER_TYPE: 
		 strError.Format(L"ERR_DSP_BUFFER_TYPE");
		 break;
    case ERR_DSP_BUFFER_SIZE: 
		 strError.Format(L"ERR_DSP_BUFFER_SIZE");
		 break;
    case ERR_DSP_BUFFER_INUSE: 
		 strError.Format(L"ERR_DSP_BUFFER_INUSE");
		 break;
    case ERR_DSP_BUFFER_NOT_READY: 
		 strError.Format(L"ERR_DSP_BUFFER_NOT_READY");
		 break;

    //-2400:
    case ERR_DSP_STOP_BY_P_CHANGE: 
		 strError.Format(L"ERR_DSP_STOP_BY_P_CHANGE");
		 break;
    case ERR_DSP_CLEAR_STOP: 
		 strError.Format(L"ERR_DSP_CLEAR_STOP");
		 break;
    case ERR_DSP_STOP_BY_GINP: 
		 strError.Format(L"ERR_DSP_STOP_BY_GINP");
		 break;
    case ERR_DSP_STOP_BY_AXIS_IO: 
		 strError.Format(L"ERR_DSP_STOP_BY_AXIS_IO");
		 break;

    //-2500:
    case ERR_DSP_NO_AVAILABLE_MACRO: 
		 strError.Format(L"ERR_DSP_NO_AVAILABLE_MACRO");
		 break;
    case ERR_DSP_MACRO_INUSE: 
		 strError.Format(L"ERR_DSP_MACRO_INUSE");
		 break;
    case ERR_DSP_MACRO_EMPTY: 
		 strError.Format(L"ERR_DSP_MACRO_EMPTY");
		 break;

    //-2600:
    case ERR_DSP_HOMING_IN_PROGRESS: 
		 strError.Format(L"ERR_DSP_HOMING_IN_PROGRESS");
		 break;

    //-3000:
    case ERR_DSP_OUTPUT_SATURATION: 
		 strError.Format(L"ERR_DSP_OUTPUT_SATURATION");
		 break;
    case ERR_DSP_ERR_MSG_BUF_EMPTY: 
		 strError.Format(L"ERR_DSP_ERR_MSG_BUF_EMPTY");
		 break;
    case ERR_DSP_ERR_MSG_BUF_OVERFLOW: 
		 strError.Format(L"ERR_DSP_ERR_MSG_BUF_OVERFLOW");
		 break;

     //-4000:
    case ERR_DSP_ERR_TEST_FRAM: 
		 strError.Format(L"ERR_DSP_ERR_TEST_FRAM");
		 break;
    case ERR_DSP_ERR_TEST_DPRAM: 
		 strError.Format(L"ERR_DSP_ERR_TEST_DPRAM");
		 break;
	default:
		strError.Format(L"UNDEFINED_ERROR");

	}


    //eRET eError,  CStringW strFunName, DWORD AxisNo
    //strRet.Format(L"Err: %s (%d), Axis:%d (%s)",strError, (long)eError, AxisNo, strFunName);
    strRet.Format(L"Err: %s (%d), %s",strError, (long)eError, strFuncNameW);

	
    
	//c_listLog.AddString((CString)strRet);
	//c_listLog.SetCurSel(c_listLog.GetCount()-1);

	::OutputDebugStringW(strRet);

	return strRet;

}