
// PCIELM4_HomingDlg.h : header file
//

#pragma once
#include "PCIELM4_MC.h"
#include "afxwin.h"


// CPCIELM4_HomingDlg dialog
class CPCIELM4_HomingDlg : public CDialog
{
// Construction
public:
	CPCIELM4_HomingDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_PCIELM4_HOMING_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()


public:
	BYTE m_bBoardNo;
	BYTE m_bAxisNo;
	BOOL m_flgCardInitialized;

	HBITMAP m_hBmpOn;
	HBITMAP m_hBmpOff;

	CEdit c_BoardNo;
	CListBox c_listLog;
	CButton c_btnConnect;
	CButton c_btnDisconnect;
	CButton c_btnServoOnAxis;
	CButton c_btnServoResetAlrmAxis;
	CButton c_btnServoResetAxis;
	CButton c_btnMoveAxis;
	CButton c_btnStopAxis;
	CButton c_btnHomeConfig;
	CButton c_btnStartHome;
	CButton c_btnHomeStop;
	CComboBox c_cboAxisNo;
	
	void ButtonEnable(BOOL flgTrueFalse);
	int IniSetting(void);
	void ReflashHomeData(BYTE AxisNo);

	afx_msg void OnBnClickedbtnclearlog();
	afx_msg void OnBnClickedbtnconnect();
	afx_msg void OnBnClickedbtndisconnect();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnBnClickedbtn_Stop();
	afx_msg void OnBnClickedbtn_Move();
	afx_msg void OnBnClickedbtn_ServoON();
	afx_msg void OnBnClickedbtn_ResetAlarm();
	afx_msg void OnBnClickedbtn_ResetCnt();
	afx_msg void OnBnClickedbtn_Sethome();
	afx_msg void OnBnClickedbtn_HomeMove();
	afx_msg void OnBnClickedbtn_StopHome();
	afx_msg void OnCbnSelchange_AxisNo();


	struct stHOMEData{

		BYTE HomeLogic;
		BYTE SLDLogic;
		BYTE EZLogic;
		BYTE HomeSteps;
		long Step4Offset;

		DWORD StartSpeed;
		DWORD Acceleration;
		DWORD Deceleration;
		DWORD HighSpeed;
		DWORD LowSpeed;
		BYTE HomingDirection;
	}m_stHome[PCIELM4_MAX_AXIS_NO];
};
