
// PCIELM4_MultiAxisDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PCIELM4_MultiAxis.h"
#include "PCIELM4_MultiAxisDlg.h"

#include "PCIELM4_MC.h"
#include "ErrorStr.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#define BOARD_NO        0
#define MAX_AXIS_NUM	2

#define AXIS_DO_SVON	0
#define AXIS_DO_RALM	1

#define MOVE_TYPE_RELATIVE	0
#define MOVE_TYPE_ABSOLUTE	1
#define MOVE_TYPE_VELOCITY	2

#define SPEED_TYPE_T_CURVE	0
#define SPEED_TYPE_S_CURVE	1


#define _CHK(PCIELM4_API)\
	lRet = PCIELM4_API;\
	if( lRet != PCIELM4_SUCCESS)\
	{\
	CStringA strApi;\
	CStringW strRet;\
	strApi.Format("" #PCIELM4_API "\n");\
	strRet = GetErrorString(lRet, strApi, m_bBoardNo, AxisNo);\
	c_listLog.InsertString(0, strRet);\
	c_listLog.SetCurSel(0);\
	}



// CPCIELM4_MultiAxisDlg dialog

CPCIELM4_MultiAxisDlg::CPCIELM4_MultiAxisDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPCIELM4_MultiAxisDlg::IDD, pParent)
	,m_bBoardNo(BOARD_NO)
	,m_flgCardInitialized(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPCIELM4_MultiAxisDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_lstLog, c_listLog);
	DDX_Control(pDX, IDC_EDIT_BOARD_NO, c_BoardNo);
	DDX_Control(pDX, IDC_rdoR, c_radioRelativePosition);
	DDX_Control(pDX, IDC_rdoA, c_radioAbsolutePosition);
	DDX_Control(pDX, IDC_rdoV, c_radioVelocityMove);
	DDX_Control(pDX, IDC_RDO_TCURVE, c_radioTcurve);
	DDX_Control(pDX, IDC_RDO_SCURVE, c_radioScurve);
	DDX_Control(pDX, IDC_btnConnect, c_btnConnect);
	DDX_Control(pDX, IDC_btnDisconnect, c_btnDisconnect);
	DDX_Control(pDX, IDC_CHK_AXIS_0, c_chkAxis0);
	DDX_Control(pDX, IDC_CHK_AXIS_1, c_chkAxis1);
	DDX_Control(pDX, IDC_rdoARCCW, c_radioCircleCW);
	DDX_Control(pDX, IDC_rdoARCCCW, c_radioCircleCCW);
	DDX_Control(pDX, IDC_cmbAxisARCX, m_cmboArcAxis0);
	DDX_Control(pDX, IDC_cmbAxisARCY, m_cmboArcAxis1);
	DDX_Control(pDX, IDC_btnSvon0, c_btnServoOnAxis0);
	DDX_Control(pDX, IDC_btnSvon1, c_btnServoOnAxis1);
	DDX_Control(pDX, IDC_btnRALM0, c_btnServoResetAlrmAxis0);
	DDX_Control(pDX, IDC_btnRALM1, c_btnServoResetAlrmAxis1);
	DDX_Control(pDX, IDC_btnResetCnt0, c_btnServoResetAxis0);
	DDX_Control(pDX, IDC_btnResetCnt1, c_btnServoResetAxis1);
	DDX_Control(pDX, IDC_btnResetCntAll, c_btnServoResetAll);
	DDX_Control(pDX, IDC_BTN_LINE_MOVE, c_btnLineMove);
	DDX_Control(pDX, IDC_btnMoveARC, c_btnArcMove);
	DDX_Control(pDX, IDC_btnStopALL, c_btnStopAll);
}

BEGIN_MESSAGE_MAP(CPCIELM4_MultiAxisDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
	ON_CONTROL_RANGE(BN_CLICKED, IDC_btnResetCnt0, IDC_btnResetCnt1, OnbtnResetCnt)
	ON_CONTROL_RANGE(BN_CLICKED, IDC_btnSvon0, IDC_btnSvon1, OnbtnSvon)
	ON_CONTROL_RANGE(BN_CLICKED, IDC_btnRALM0, IDC_btnRALM1, OnbtnRALM)
	ON_BN_CLICKED(IDC_btnResetCntAll, &CPCIELM4_MultiAxisDlg::OnBnClickedbtnresetcntall)
	ON_BN_CLICKED(IDC_btnStopALL, &CPCIELM4_MultiAxisDlg::OnBnClickedbtnstopall)
	ON_BN_CLICKED(IDC_btnClearLog, &CPCIELM4_MultiAxisDlg::OnBnClickedbtnclearlog)
	ON_BN_CLICKED(IDC_btnConnect, &CPCIELM4_MultiAxisDlg::OnBnClickedbtnconnect)
	ON_BN_CLICKED(IDC_btnDisconnect, &CPCIELM4_MultiAxisDlg::OnBnClickedbtndisconnect)

	ON_BN_CLICKED(IDC_BTN_LINE_MOVE, &CPCIELM4_MultiAxisDlg::OnBnClicked_BtnLineMove)
	ON_BN_CLICKED(IDC_btnMoveARC, &CPCIELM4_MultiAxisDlg::OnBnClickedbtn_MoveArc)
END_MESSAGE_MAP()


// CPCIELM4_MultiAxisDlg message handlers

BOOL CPCIELM4_MultiAxisDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	//----------------------------------------
	//Connection:
	//----------------------------------------
	c_BoardNo.SetWindowTextW(L"0");
	ButtonEnable(FALSE);

	

	//----------------------------------------
	//Axis Setting:
	//----------------------------------------
	//Speed and Accelleration:
	SetDlgItemInt(IDC_edtSpeed, 5000);
	SetDlgItemInt(IDC_edtAcc, 20000);
	c_radioRelativePosition.SetCheck(BST_CHECKED);
	c_radioTcurve.SetCheck(BST_CHECKED);


	//----------------------------------------
	//For Multi-Axis Linear Motion:
	//----------------------------------------
	SetDlgItemInt(IDC_edtDist0 , 20000);
	SetDlgItemInt(IDC_edtDist1 , 20000);
	c_chkAxis0.SetCheck(BST_CHECKED);
	c_chkAxis1.SetCheck(BST_CHECKED);


	//----------------------------------------
	//For Circular Motion:
	//----------------------------------------
	SetDlgItemInt(IDC_edtDistCX, 10000);
	SetDlgItemInt(IDC_edtDistCY, 0);
	SetDlgItemInt(IDC_edtDistEX, 20000);
	SetDlgItemInt(IDC_edtDistEY, 0);
	c_radioCircleCW.SetCheck(BST_CHECKED);
	m_cmboArcAxis0.SetCurSel(0);
	m_cmboArcAxis1.SetCurSel(1);


	SetTimer(1, 10, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPCIELM4_MultiAxisDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPCIELM4_MultiAxisDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CPCIELM4_MultiAxisDlg::OnTimer(UINT_PTR nIDEvent)
{
	long lRet = 0;
	int i = 0;
	CString str;
	BYTE AxisNo = 0;
	long LogicPos = 0, EncPos = 0, Speed = 0 ;
	BYTE Done = 0;
	WORD StopStatus = 0;
	WORD IOStatus = 0/*, DIStatus = 0*/;
	static BOOL flgDisCon = FALSE; 

	if ( m_flgCardInitialized == TRUE )
	{
		for (i = 0; i < MAX_AXIS_NUM; i++)
		{
			AxisNo = 0x01 << i;

			_CHK(pcielm4_get_cmdcounter(m_bBoardNo, AxisNo, &LogicPos) );
			SetDlgItemInt(IDC_edtCmdCnt0 + i, LogicPos);

			_CHK(pcielm4_get_enccounter(m_bBoardNo, AxisNo, &EncPos) );
			SetDlgItemInt(IDC_edtEncCnt0 + i, EncPos);

			_CHK(pcielm4_get_speed(m_bBoardNo, AxisNo, &Speed) );
			SetDlgItemInt(IDC_edtCurSpeed0 + i, Speed);

			_CHK(pcielm4_get_motion_done( m_bBoardNo, AxisNo, &Done, &StopStatus )  );
			str.Format(L"%d_0x%04x", Done, StopStatus);
			SetDlgItemText(IDC_edtMotionSts0 + i, str);

			_CHK(pcielm4_get_mdi_status( m_bBoardNo, AxisNo, &IOStatus )  );
			str.Format(L"0x%04x", IOStatus);
			SetDlgItemText(IDC_edtIOSts0 + i, str);
		}

		flgDisCon = FALSE;
	}
	else
	{
		if (flgDisCon == FALSE)
		{
			flgDisCon = TRUE;
			for (i = 0; i < MAX_AXIS_NUM; i++)
			{
				SetDlgItemText(IDC_edtCmdCnt0 + i, L"NULL");
				SetDlgItemText(IDC_edtEncCnt0 + i, L"NULL");
				SetDlgItemText(IDC_edtCurSpeed0 + i, L"NULL");
				SetDlgItemText(IDC_edtMotionSts0 + i, L"NULL");
				SetDlgItemText(IDC_edtIOSts0 + i, L"NULL");
			}
		}
	}

	CDialog::OnTimer(nIDEvent);
}

void CPCIELM4_MultiAxisDlg::OnBnClickedbtnconnect()
{
	long lRet = 0;
	BYTE AxisNo = 0;
	int i = 0;
	CStringW strTemp;
	WORD Ver = 0, FWVer = 0, DSPVer = 0, PCBVer = 0, PLDVer = 0, FPGAVer = 0;
	
	m_flgCardInitialized = FALSE;

	c_BoardNo.GetWindowTextW(strTemp);
	m_bBoardNo = (BYTE) _wtol(strTemp);

	c_btnConnect.EnableWindow(FALSE);


	//-------------------------------
	//STEP 1: Open Driver
	//-------------------------------
	lRet = pcielm4_open_driver();
	if(lRet != PCIELM4_SUCCESS)
	{
		AfxMessageBox(L"Open PCIELM4 driver failed!");
		c_btnConnect.EnableWindow(TRUE);
		c_btnDisconnect.EnableWindow(FALSE);
		return;
	}

	//-------------------------------
	//STEP 2: Check PCIELM4 is in PCIe Slot
	//-------------------------------
	lRet =  pcielm4_check_card_in_slot( m_bBoardNo );
	if(lRet != PCIELM4_SUCCESS)
	{
		AfxMessageBox(L"PCIELM4 board %d was not detected!", m_bBoardNo);
		c_btnConnect.EnableWindow(TRUE);
		c_btnDisconnect.EnableWindow(FALSE);
		return;
	}

	//-------------------------------
	//STEP 3: Intialize PCIELM4 card
	//-------------------------------
	pcielm4_registration( m_bBoardNo );

	m_flgCardInitialized = TRUE;
	
	//WritePrivateProfileString("TestParam", "IP", strTemp, ".\\TestParam.ini");

	_CHK(pcielm4_get_dsp_firmware_version( m_bBoardNo, &DSPVer) );
	_CHK(pcielm4_get_card_version( m_bBoardNo, &PCBVer, &PLDVer) );
	_CHK(pcielm4_get_fpga_version( m_bBoardNo, &FPGAVer) );
	strTemp.Format(L"Firmware Ver.: 0x%04x, PCB Ver.: 0x%04x", DSPVer, PCBVer);
	SetDlgItemText(IDC_edtCardInfo, strTemp);

	IniSetting();
	ButtonEnable(TRUE);

}

void CPCIELM4_MultiAxisDlg::OnBnClickedbtndisconnect()
{
	m_flgCardInitialized = FALSE;
	pcielm4_close_driver();

	ButtonEnable(FALSE);
}

void CPCIELM4_MultiAxisDlg::OnbtnResetCnt(UINT nID)
{
	BYTE Axis = nID - IDC_btnResetCnt0;

	ResetAxisCnt(Axis);
}

void CPCIELM4_MultiAxisDlg::OnBnClickedbtnresetcntall()
{
	BYTE Axis = 0;

	for (Axis = 0; Axis < MAX_AXIS_NUM; Axis++)
	{ResetAxisCnt(Axis);}
}

void CPCIELM4_MultiAxisDlg::OnBnClickedbtnstopall()
{
	BYTE Axis = 0;
	for (Axis = 0; Axis < MAX_AXIS_NUM; Axis++)
	{StopAxis(Axis);}
}

void CPCIELM4_MultiAxisDlg::OnbtnSvon(UINT nID)
{
	BYTE Axis = nID - IDC_btnSvon0;
	AxisDO(Axis, AXIS_DO_SVON);
}

void CPCIELM4_MultiAxisDlg::OnbtnRALM(UINT nID)
{
	BYTE Axis = nID - IDC_btnRALM0;
	AxisDO(Axis, AXIS_DO_RALM);
}

void CPCIELM4_MultiAxisDlg::OnBnClickedbtnclearlog()
{
	c_listLog.ResetContent();
}

int CPCIELM4_MultiAxisDlg::StopAxis(BYTE Axis)
{
	BYTE AxisNo = 0x01 << Axis;
	long lRet = 0;
	BYTE StopMode = STOP_SUDDEN;

	// StopMode = 1: slow down then stop, 2: sudden stop
	_CHK(pcielm4_stop_move( m_bBoardNo, AxisNo, StopMode ) );

	return 0;
}
int CPCIELM4_MultiAxisDlg::ResetAxisCnt(BYTE Axis)
{
	BYTE AxisNo = 0x01 << Axis;
	long LogicPos = 0;
	long EncPos = 0;
	long lRet = 0;

	_CHK(pcielm4_set_cmdcounter(m_bBoardNo, AxisNo, LogicPos) );
	_CHK(pcielm4_set_enccounter(m_bBoardNo, AxisNo, EncPos) );

	return 0;
}

int CPCIELM4_MultiAxisDlg::AxisDO(BYTE Axis, BYTE Ch)
{
	BYTE AxisNo = 0x01 << Axis;
	long lRet = 0;
	BYTE OnOff = FALSE;

	if (Ch == AXIS_DO_SVON)
	{
		_CHK(pcielm4_get_servo_on_status(m_bBoardNo, AxisNo, &OnOff ) );

		if (OnOff)
		{_CHK(pcielm4_set_servo_on( m_bBoardNo, AxisNo, FALSE ) );}
		else
		{_CHK(pcielm4_set_servo_on( m_bBoardNo, AxisNo, TRUE ) );}

	}
	else if (Ch == AXIS_DO_RALM)
	{        
		_CHK(pcielm4_get_servo_almrst_status(m_bBoardNo, AxisNo, &OnOff ) );
		if (OnOff)
		{_CHK(pcielm4_set_alarm_reset( m_bBoardNo, AxisNo, FALSE ) );}
		else
		{_CHK(pcielm4_set_alarm_reset( m_bBoardNo, AxisNo, TRUE ) );}		
	}
	return 0;
}

int CPCIELM4_MultiAxisDlg::IniSetting(void)
{
	int i = 0;
	long lRet = 0;
	BYTE AxisNo = 0;

	BYTE HomeSteps = AUTO_HOME_STEP1_ENABLE | AUTO_HOME_STEP2_ENABLE | AUTO_HOME_STEP3_ENABLE | AUTO_HOME_STEP4_ENABLE; 

	_CHK(pcielm4_set_conti_interp_cfg(m_bBoardNo, FALSE, 0x03 ) );

	for (i = 0; i < MAX_AXIS_NUM; i++)
	{
		AxisNo = 0x0001 << i;	

		_CHK(pcielm4_set_pls_cfg(m_bBoardNo, AxisNo, PULSE_MODE_AB_DIVID_4, FALSE, FALSE ) );
		_CHK(pcielm4_set_enc_cfg(m_bBoardNo, AxisNo, ENCODER_MODE_AB_DIVID_4 ) );

		_CHK(pcielm4_set_limit(m_bBoardNo, AxisNo, FALSE, STOP_SUDDEN) );
		//_CHK(pcielm4_set_softlimit( m_bBoardNo, AxisNo, STOP_SUDDEN, REF_CMD_CNT, 0x7FFFFFFF, -0x7FFFFFFF) );
		_CHK(pcielm4_set_softlimit_disable(m_bBoardNo, AxisNo) );
		_CHK(pcielm4_set_home_cfg(m_bBoardNo, AxisNo, FALSE, FALSE, FALSE, HomeSteps, 0) );
		_CHK(pcielm4_set_alarm( m_bBoardNo, AxisNo, TRUE, FALSE ) );
		_CHK(pcielm4_set_inp( m_bBoardNo, AxisNo, FALSE, FALSE ) );
		_CHK(pcielm4_set_ready( m_bBoardNo, AxisNo, FALSE, FALSE ) );
		_CHK(pcielm4_set_latch_cfg( m_bBoardNo, AxisNo, FALSE, FALSE ) );
		_CHK(pcielm4_disable_vring_counter( m_bBoardNo, AxisNo) );
	}

	return 0;
}

void CPCIELM4_MultiAxisDlg::OnBnClicked_BtnLineMove()
{
	long lRet = 0;
	BYTE AxisNo = 0;
	long AxisCnt = 0;
	BYTE AxisIdx = 0;
	BYTE bAxisArray[MAX_AXIS_QTY]={0};
	long lDistarray[MAX_AXIS_QTY]={0};
	DWORD StartSpeed = 0, DriveSpeed = 0, Acc = 0, Dec = 0;
	BYTE Type = MOVE_TYPE_RELATIVE;
	CStringW strTemp;

	DriveSpeed = GetDlgItemInt(IDC_edtSpeed);
	StartSpeed = DriveSpeed / 2;
	Acc = GetDlgItemInt(IDC_edtAcc);
	Dec = Acc;

	//---------------------------------------
	//Check which axis has been selected
	//---------------------------------------
	if(c_chkAxis0.GetCheck() == BST_CHECKED)
	{	
		AxisCnt++;
		AxisIdx = 0;
		bAxisArray[AxisIdx] = AXIS_0;
		lDistarray[AxisIdx] = GetDlgItemInt(IDC_edtDist0+0); 
	}

	if(c_chkAxis1.GetCheck() == BST_CHECKED)
	{	
		AxisCnt++;
		AxisIdx = 1;
		bAxisArray[AxisIdx] = AXIS_1;
		lDistarray[AxisIdx] = GetDlgItemInt(IDC_edtDist0+1);
	}

	//---------------------------------------
	//Check Move Type:
	//---------------------------------------
	if (c_radioRelativePosition.GetCheck() == BST_CHECKED)
	{
		switch (AxisCnt)
		{
		case 0:
			strTemp.Format(L"No axis selected");
			c_listLog.InsertString(0, strTemp);
			break;
		case 1:
			_CHK(pcielm4_t_move(m_bBoardNo, bAxisArray[AxisIdx], 
				StartSpeed, DriveSpeed, StartSpeed, Acc, Dec, lDistarray[AxisIdx])  );
			break;
		case 2:
			_CHK(pcielm4_t_line2_move(m_bBoardNo,bAxisArray[0],bAxisArray[1],
				StartSpeed, DriveSpeed, StartSpeed, Acc, Dec,lDistarray[0],lDistarray[1],
				GENERAL_INTERP_CONFIG) );
			break;
		}
	}
	else if (c_radioAbsolutePosition.GetCheck() == BST_CHECKED)
	{
		switch (AxisCnt)
		{
		case 0:
			strTemp.Format(L"No axis selected");
			c_listLog.InsertString(0, strTemp);
			break;
		case 1:
			_CHK(pcielm4_abs_t_move(m_bBoardNo, bAxisArray[AxisIdx], 
				StartSpeed, DriveSpeed, StartSpeed, Acc, Dec, lDistarray[AxisIdx]));
			break;
		case 2:
			_CHK(pcielm4_abs_t_line2_move(m_bBoardNo,bAxisArray[0],bAxisArray[1],
				StartSpeed, DriveSpeed,StartSpeed, Acc, Dec,lDistarray[0],lDistarray[1],
				GENERAL_INTERP_CONFIG) );
			break;
		}
	}
	else
	{
		strTemp.Format(L"Command not supported");
		c_listLog.InsertString(0, strTemp);
	}

}

void CPCIELM4_MultiAxisDlg::OnBnClickedbtn_MoveArc()
{
	long lRet = 0;
	BYTE AxisNo = 0;
	DWORD StartSpeed = 0, DriveSpeed = 0, Acc = 0, Dec = 0;
	long DistCX = 0, DistCY = 0, DistEX = 0, DistEY = 0;
	BYTE eArcDir;

	BYTE AxisX = (0x01<<m_cmboArcAxis0.GetCurSel());
	BYTE AxisY = (0x01<<m_cmboArcAxis1.GetCurSel());


	if (c_radioCircleCW.GetCheck())
	{eArcDir = ARC_DIR_CW;}
	else
	{eArcDir = ARC_DIR_CCW;}

	DriveSpeed = GetDlgItemInt(IDC_edtSpeed);
	StartSpeed = DriveSpeed / 2;
	Acc = GetDlgItemInt(IDC_edtAcc);
	Dec = Acc;

	DistCX = GetDlgItemInt(IDC_edtDistCX);
	DistCY = GetDlgItemInt(IDC_edtDistCY);

	DistEX = GetDlgItemInt(IDC_edtDistEX);
	DistEY = GetDlgItemInt(IDC_edtDistEY);

	if (c_radioRelativePosition.GetCheck() == BST_CHECKED)
	{
		_CHK(pcielm4_t_arc2_move(m_bBoardNo,AxisX,AxisY,StartSpeed,DriveSpeed,StartSpeed,Acc,Dec,eArcDir,
			DistCX, DistCY, DistEX, DistEY, GENERAL_INTERP_CONFIG));
	}
	else if (c_radioAbsolutePosition.GetCheck() == BST_CHECKED)
	{
		_CHK(pcielm4_abs_t_arc2_move(m_bBoardNo,AxisX,AxisY,StartSpeed,DriveSpeed,StartSpeed,Acc,Dec,eArcDir,
			DistCX, DistCY, DistEX, DistEY, GENERAL_INTERP_CONFIG));
	}
	else
	{
		CStringW strTemp;
		strTemp.Format(L"Command not supported");
		c_listLog.InsertString(0, strTemp);
	} 

}

void CPCIELM4_MultiAxisDlg::ButtonEnable(BOOL flgTrueFalse)
{
	c_btnConnect.EnableWindow( (flgTrueFalse==TRUE)?FALSE:TRUE);
	c_btnDisconnect.EnableWindow(flgTrueFalse);
	c_btnServoOnAxis0.EnableWindow(flgTrueFalse);
	c_btnServoOnAxis1.EnableWindow(flgTrueFalse);
	c_btnServoResetAlrmAxis0.EnableWindow(flgTrueFalse);
	c_btnServoResetAlrmAxis1.EnableWindow(flgTrueFalse);
	c_btnServoResetAxis0.EnableWindow(flgTrueFalse);
	c_btnServoResetAxis1.EnableWindow(flgTrueFalse);
	c_btnServoResetAll.EnableWindow(flgTrueFalse);
	c_btnStopAll.EnableWindow(flgTrueFalse);
	c_btnLineMove.EnableWindow(flgTrueFalse);
	c_btnArcMove.EnableWindow(flgTrueFalse);
}
